//******************************************************************************
//                                                                            //
//    PADDLE WAR ! by Simon B. Adam, 1998                                     //
//                                                                            //
//    I did NOT comment this file because I think it's very easy to           //
//    understand all commands: I wrote this program in about 45 minutes...    //
//                                                                            //
//    please drop me a mail: trash1024@hotmail.com                            //
//    or visit my page: http://www.fortunecity.com/skyscraper/cyrix/234/      //
//                                                                            //
//******************************************************************************

unit Unit1;

INTERFACE

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, ExtCtrls, StdCtrls, Buttons, Spin;

type
  TForm1 = class(TForm)
    Image1: TImage;
    MainMenu1: TMainMenu;
    Spiel1: TMenuItem;
    Start1: TMenuItem;
    Ende1: TMenuItem;
    Timer1: TTimer;
    Label1: TLabel;
    Optionen1: TMenuItem;
    Farben1: TMenuItem;
    Spieler1: TMenuItem;
    CPU1: TMenuItem;
    Hintergrund1: TMenuItem;
    Blue1: TMenuItem;
    Red1: TMenuItem;
    Yellow1: TMenuItem;
    White1: TMenuItem;
    Lightgreen1: TMenuItem;
    Lightblue1: TMenuItem;
    Black1: TMenuItem;
    Navy1: TMenuItem;
    Maroon1: TMenuItem;
    Pause1: TMenuItem;
    About1: TMenuItem;
    Timer2: TTimer;
    Timer3: TTimer;
    Needhelp1: TMenuItem;
    Speed1: TMenuItem;
    Panel1: TPanel;
    SpinEdit1: TSpinEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Ende1Click(Sender: TObject);
    procedure Start1Click(Sender: TObject);
    procedure PaintPaddles(Sender: TObject);
    procedure PaintBackground(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
    procedure ViewLabel(Sender: TObject);
    procedure Start(Sender: TObject);
    procedure PaintBorders(Sender: TObject);
    procedure Blue1Click(Sender: TObject);
    procedure Red1Click(Sender: TObject);
    procedure Yellow1Click(Sender: TObject);
    procedure White1Click(Sender: TObject);
    procedure Lightgreen1Click(Sender: TObject);
    procedure Lightblue1Click(Sender: TObject);
    procedure Black1Click(Sender: TObject);
    procedure Navy1Click(Sender: TObject);
    procedure Maroon1Click(Sender: TObject);
    procedure Pause1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure Needhelp1Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Speed1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  X, Y, X1, Y1, Xb, Yb, Xbb, Ybb, CPUPoints, PlayerPoints, Xtext, Ytext,
   A, B, C, D : Integer;
  PaddleColor, CPUColor, Background, BallColor : TColor;
  Count : Real;
  Ende : Boolean;

IMPLEMENTATION

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  Background := 0;
  CPUColor := clWhite;
  PaddleColor := clBlue;
  BallColor := clGreen;
  PaintBackground(Sender);
end;

procedure TForm1.Ende1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.PaintBackground(Sender: TObject);
begin
  with Image1.Canvas do begin
    Pen.Color := Background;
    Brush.Color := Background;
    FillRect(Rect(0,0, Image1.Width,Image1.Height));
  end;
end;

procedure TForm1.PaintBorders(Sender: TObject);
begin
  with Image1.Canvas do begin
    Pen.Color := clGray;
    Pen.Width := 1;
      MoveTo(10,0); LineTo(10,Image1.Height);
     MoveTo(Image1.Width-10,0); LineTo(Image1.Width-10,Image1.Height);
  end;
end;

procedure TForm1.PaintPaddles(Sender: TObject);
begin
  with Image1.Canvas do begin
    Pen.Width := 10;
    Pen.Color := Background;
      MoveTo(0,Y); LineTo(Image1.Width,Y);
    Pen.Color := PaddleColor;
      MoveTo(X,Y); LineTo(X+20,Y);
    Pen.Color := Background;
      MoveTo(0,Y1); LineTo(Image1.Width,Y1);
    Pen.Color := CPUColor;
      MoveTo(X1,Y1); LineTo(X1+20,Y1);
    PaintBorders(Sender);
  end;
end;

procedure TForm1.Start1Click(Sender: TObject);
begin
  Pause1.Checked := False;
  PaintPaddles(Sender);
  ViewLabel(Sender);
  CPUPoints := 0; PlayerPoints := 0;
  Start(Sender);
  Timer1.Enabled := True;
  Timer2.Enabled := False;
  Timer3.Enabled := False;
  PaintBackground(Sender);
  ViewLabel(Sender);
end;

procedure TForm1.Start(Sender: TObject);
var
  A, B : integer;
begin
  X := Image1.Width div 2;
  Y := 20;
  X1 := Image1.Width div 2;
  Y1 := Image1.Height - 20;
  Xb := Image1.Width div 2;
  Yb := Image1.Height div 2;
  Xbb := random(3) + 2;
  Ybb := random(3) + 2;
  A := Random(2);
  B := Random(2);
  if A = 1 then Xbb := -Xbb;
  if B = 1 then Ybb := -Ybb;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if NOT Pause1.Checked then begin
    case Key of
      VK_LEFT : if 20 < X then X := X - 5;
      VK_RIGHT : if X < Image1.Width - 40 then X := X + 5;
    end;
    PaintPaddles(Sender);
  end;
end;

procedure TForm1.ViewLabel(Sender: TObject);
begin
  Label1.Caption := 'Player : ' + (inttostr(PlayerPoints) +
    ('                  CPU : ' + (inttostr(CPUPoints))));
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  Key : Char;
begin
  if Pause1.Checked = False then begin
    with Image1.Canvas do begin
      Pen.Width := 10;
      Pen.Color := Background;
      MoveTo(Xb,Yb); LineTo(Xb,Yb);
      if ((Xb > X) and (Xb < X + 20)) and ((Yb < Y + 8) and (Yb > Y)) then begin
        Yb := Yb + 5; Ybb := -Ybb;
      end;
      if ((Xb < X + 25) and (Xb > X + 20)) and ((Yb < Y + 8) and (Yb > Y - 3)) then begin
        if Xbb < 0 then Xbb := Xbb - 2 else Xbb := Xbb + 2; Xbb := -Xbb; Ybb := -Ybb;
      end;
      if ((Xb > X - 10) and (Xb < X)) and ((Yb < Y + 8) and (Yb > Y - 3)) then begin
        if Xbb < 0 then Xbb := Xbb - 2 else Xbb := Xbb + 2; Xbb := -Xbb; Ybb := -Ybb;
      end;
      if ((Xb < X1 + 25) and (Xb > X1 - 5)) and ((Yb > Y1 - 8) and (Yb < Y1)) then
        Ybb := -Ybb;
      if (Xb <= 10) or (Xb >= Image1.Width - 20) then begin
        Xbb := -Xbb; PaintBorders(Sender);
      end;
      if Yb > Y1 then begin
        PlayerPoints := PlayerPoints + 1; ViewLabel(Sender); Start(Sender);
      end;
      if Yb < Y then begin
        CPUPoints := CPUPoints + 1; ViewLabel(Sender); Start(Sender);
      end;
      Xb := Xb + Xbb;
      Yb := Yb + Ybb;
      if (X1 > 20) and (X1 < Image1.Width - 40) then begin
        if X1 < Xb then X1 := X1 + 5;
        if (X1 + 20) > Xb then X1 := X1 - 5;
      end else begin
        if X1 < 20 then X1 := X1 + 5;
        if X1 > Image1.Width - 40 then X1 := X1 - 5;
      end;
      Pen.Color := BallColor;
      MoveTo(Xb,Yb); LineTo(Xb,Yb);
    end;
    PaintPaddles(Sender);
    if PlayerPoints >= 20 then begin
      Pause1.Checked := True;
      with Image1.Canvas do begin
        Pen.Color := Background; Brush.Color := Background;
        FillRect(Rect(0,0, Image1.Width,Image1.Height));
        Font.Color := PaddleColor; Font.Name := 'Arial'; Font.Size := 20;
        TextOut(100,100, 'You won!');
        Font.Size := 10;
        TextOut(100,130, 'Play again? Press Y/N');
      end;
    end;
    if CPUPoints >= 20 then begin
      Pause1.Checked := True;    
      with Image1.Canvas do begin
        Pen.Color := Background; Brush.Color := Background;
        FillRect(Rect(0,0, Image1.Width,Image1.Height));
        Font.Color := PaddleColor; Font.Name := 'Arial'; Font.Size := 20;
        TextOut(100,100, 'CPU won!');
        Font.Size := 10;
        TextOut(100,130, 'Play again? Press Y/N');
      end;
    end;
  end;
end;

procedure TForm1.Blue1Click(Sender: TObject);
begin
  Red1.Checked := False; Yellow1.Checked := False;
  Blue1.Checked := True; PaddleColor := clBlue;
end;

procedure TForm1.Red1Click(Sender: TObject);
begin
  Blue1.Checked := False; Yellow1.Checked := False;
  Red1.Checked := True; PaddleColor := clRed;
end;

procedure TForm1.Yellow1Click(Sender: TObject);
begin
  Blue1.Checked := False; Red1.Checked := False;
  Yellow1.Checked := True; PaddleColor := clYellow;
end;

procedure TForm1.White1Click(Sender: TObject);
begin
  Lightgreen1.Checked := False; Lightblue1.Checked := False;
  White1.Checked := True; CPUColor := clWhite;
end;

procedure TForm1.Lightgreen1Click(Sender: TObject);
begin
  White1.Checked := False; Lightblue1.Checked := False;
  Lightgreen1.Checked := True; CPUColor := clLime;
end;

procedure TForm1.Lightblue1Click(Sender: TObject);
begin
  White1.Checked := False; Lightgreen1.Checked := False;
  Lightblue1.Checked := True; CPUColor := clAqua;
end;

procedure TForm1.Black1Click(Sender: TObject);
begin
  Maroon1.Checked := False; Navy1.Checked := False;
  Black1.Checked := True; Background := clBlack;
  PaintBackground(Sender);
end;

procedure TForm1.Navy1Click(Sender: TObject);
begin
  Black1.Checked := False; Maroon1.Checked := False;
  Navy1.Checked := True; Background := clNavy;
  PaintBackground(Sender);
end;

procedure TForm1.Maroon1Click(Sender: TObject);
begin
  Black1.Checked := False; Navy1.Checked := False;
  Maroon1.Checked := True; Background := clMaroon;
  PaintBackground(Sender);
end;

procedure TForm1.Pause1Click(Sender: TObject);
begin
  X := Image1.Width div 2;
  Y := 20;
  Panel1.Visible := False;
  Timer2.Enabled := False;
  Timer3.Enabled := False;
  PaintBackground(Sender);
  if Pause1.Checked = True then Pause1.Checked := False
   else Pause1.Checked := True;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  Pause1.Checked := True;
  Timer3.Enabled := False;
  Timer2.Enabled := True;
  Xtext := 10;
  Ytext := Image1.Height - 20;
  A := -100; B := Image1.Width - 30;
  Ende := False;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  if Ende = False then Ytext := Ytext - 1;
  if A < 100 then A := A + 1;
  B := B - 1;
  with Image1.Canvas do begin
    Pen.Color := clBlack; Brush.Color := clBlack;
    FillRect(Rect(0,0, Image1.Width,Image1.Height));
    Font.Color := clLime; Font.Name := 'Arial'; Font.Size := 20;
      TextOut(Xtext,Ytext, 'Paddle War!');
    Font.Color := clYellow; Font.Name := 'TimesNewRoman'; Font.Size := 10;
      TextOut(A,Ytext + 30, '32-Bit -Version 0.1');
    Font.Color := clRed; Font.Name := 'TimesNewRoman'; Font.Size := 10;
      TextOut(B,Ytext + 45, '<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>');
    Font.Color := clYellow; Font.Name := 'TimesNewRoman'; Font.Size := 10;
      TextOut(A,Ytext + 60, 'Developed by Sam in 1997 / 1998');
    Font.Color := clBlue; Font.Name := 'TimesNewRoman'; Font.Size := 10;
      TextOut(B,Ytext + 100, 'WWW :');
      TextOut(A,Ytext + 115, 'http://www.fortunecity.com/skyscraper/cyrix/234/');
    Font.Color := clRed; Font.Name := 'TimesNewRoman'; Font.Size := 10;
      TextOut(B,Ytext + 145, 'eMail :');
      TextOut(A,Ytext + 160, 'Trash1024@hotmail.com');
    Font.Color := clYellow; Font.Name := 'Arial'; Font.Size := 8;
      TextOut(Xtext,Ytext + 180, 'This program has NO copyrights.');
      TextOut(Xtext,Ytext + 195, 'You''re allowed to use and copy it for free.');
      TextOut(Xtext,Ytext + 210, 'Commercial using is not allowed.');
  end;
  if Ytext < 0 then Ende := True;
  if B < 50 then Timer2.Enabled := False;
end;

procedure TForm1.Timer3Timer(Sender: TObject);
begin
  Ytext := Ytext - 1;
  X := X - 1;
  if C > 20 then C := C - 1;
  with Image1.Canvas do begin
    Pen.Color := clBlack; Brush.Color := clBlack;
    FillRect(Rect(0,0, Image1.Width,Image1.Height));
    Font.Color := clLime; Font.Name := 'Arial'; Font.Size := 20;
      TextOut(C,Ytext, 'Help!');
    Font.Color := clRed; Font.Name := 'Arial'; Font.Size := 8;
      TextOut(Xtext,Ytext + 40,  'Control your Paddle (it''s the one on the top) by pressing the LEFT');
      TextOut(Xtext,Ytext + 55,  'or RIGHT key  of your keyboard.  You should try to  catch the ball ');
      TextOut(Xtext,Ytext + 70, '(it''s green)  with your Paddle and throw  it behind the  CPU Paddle.');
      TextOut(Xtext,Ytext + 85, 'But pay attention!  Most times the CPU hits the ball back to you and');
      TextOut(Xtext,Ytext + 100, 'you have to hit it back again.  To get the ball behind the CPU, hit the');
      TextOut(Xtext,Ytext + 115, 'ball  with one of the edges of your Paddle.  So the ball becomes');
      TextOut(Xtext,Ytext + 130, 'much faster and the CPU wont be able to catch it.');
      TextOut(Xtext,Ytext + 145, 'When the ball arrives behind one of the two Paddles the other');
      TextOut(Xtext,Ytext + 160, '(player or CPU) will get one point. To win you have to make 20');
      TextOut(Xtext,Ytext + 175, 'points and to lose the CPU have to make 20 points.');
      TextOut(Xtext,Ytext + 190, '>>> Have a lot of fun!');
    Pen.Color := clGreen; Pen.Width := 1;
      RectAngle(X - 10,Y - 10, X + 100,Y + 75);
    Pen.Color := clWhite; Pen.Width := 10;
      MoveTo(X,Y); LineTo(X + 20,Y);
    Pen.Color := PaddleColor;
      MoveTo(X+3,Y); LineTo(X + 17,Y);
    Font.Color := clYellow; Font.Name := 'Arial'; Font.Size := 7;
      TextOut(X,Y + 10, 'Hit the ball with');
      TextOut(X,Y + 25, 'one of the edges.');
      TextOut(X,Y + 40, '(Here they are');
      TextOut(X,Y + 55, 'white marked)');
  end;
  if Ytext < 0 then Timer3.Enabled := False;
end;

procedure TForm1.Needhelp1Click(Sender: TObject);
begin
  Pause1.Checked := True;
  C := Image1.Width - 30;
  Pause1.Enabled := True;
  Timer2.Enabled := False;
  Timer3.Enabled := True;
  Xtext := 10; Ytext := Image1.Height - 20;
  X := Image1.Width + 125;
  Y := 100;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if PlayerPoints >= 20 then begin
    if (Key = 'N') or (Key = 'n') then About1Click(Sender)
     else Start1Click(Sender);
  end;
  if CPUPoints >= 20 then begin
    if (Key = 'N') or (Key = 'n') then About1Click(Sender)
     else Start1Click(Sender);
  end;
end;

procedure TForm1.Speed1Click(Sender: TObject);
begin
  Pause1.Checked := True;
  Panel1.Visible := True;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  Pause1.Checked := False;
  Panel1.Visible := False;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Timer1.Interval := SpinEdit1.Value;
  Panel1.Visible := False;
  Pause1.Checked := False;
end;

END.
